---
navigation: true
title: Introduction
main:
  fluid: false
---
:ellipsis{left=0px width=40rem top=10rem blur=140px}
## Un home lab par un débutant pour les débutants

<p align="center">
<img src="/img/serveex/serveex.svg" align="center" width="700">

**Serveex** c'est avant tout un projet personnel visant à héberger chez soi le plus de services possibles du quotidien sans passer par des plateformes propriétaires (Google, Apple, Netflix...). L'idée était d'expérimenter, d'apprendre, et de documenter chaque étape. C'est un projet purement pour la science, et n'a pas vocation à être utilisé en production.

Un grand merci à **Nipah**, pour le partage de ses connaissances infinies, et surtout pour sa patience.

::alert{type="info"}
**Pré-requis :**
:::list{type="primary"}
- Posséder [un VPS en ligne](https://www.it-connect.fr/les-serveurs-prives-virtuels-vps-pour-les-debutants/) ou une machine locale : idéalement un mini PC (on trouve des N100 pour 100€), mais fonctionne aussi sur laptop ou [une machine virtuelle](https://openclassrooms.com/fr/courses/2035806-virtualisez-votre-architecture-et-vos-environnements-de-travail/6313946-installez-virtualbox). Les [Freebox Delta/Ultra proposent des machines virtuelles](https://next.ink/3493/machines-virtuelles-et-freebox-delta-comment-heberger-votre-premiere-page-web/).
- Savoir configurer les [règles NAT d'un routeur et attribuer des baux DHCP](/generalites/nat)
- Savoir configurer la [zone DNS d'un nom de domaine](/generalites/dns)
:::
::

L'objectif etant d'etre facilement déployable et facile à migrer, voici sa structure :

::card-grid{grid-template-columns="repeat(2, minmax(0, 1fr));"}
#title
Le coeur du serveur

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=logos:debian}
  #title
  __Système d'exploitation__
  #description
  [Installer et configurer Debian 12](/serveex/coeur/installation)
  ::
 
  ::card{icon=logos:docker-icon}
  #title
  __Moteur de conteneur__
  #description
  [Installer Docker](/serveex/coeur/docker)
  ::

  ::card{icon=carbon:container-registry style="color: rgb(41, 194, 243);" }
  #title
  __Docker GUI__
  #description
  [Installer et déployer Dockge](/serveex/coeur/docker#installer-dockge-pour-gérer-et-déployer-les-conteneurs)
  ::
  
  ::card{icon=noto:globe-showing-americas}
  #title
  __Reverse Proxy__
  #description
  [Exposez vos services avec SWAG](/serveex/coeur/swag)
  ::
::

::card-grid
#title
La sécurité

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=simple-icons:wireguard style="color: #88171a;"}
  #title
  __VPN__
  #description
  [Installer et déployer Wireguard](/serveex/securite/wireguard)
  ::
 
  ::card{icon=noto:key}
  #title
  __SSO & MFA__
  #description
  [Installer et déployer Authentik](/serveex/securite/authentik)
  ::

  ::card{icon=logos:cloudflare-icon}
  #title
  __Zero Trust__
  #description
  [Installer et déployer Cloudflared](/serveex/securite/cloudflare)
  ::
::

::card-grid
#title
Monitoring

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=solar:pulse-linear style="color: rgb(99, 222, 144);"}
  #title
  __Etat des services__
  #description
  [Installer et déployer Uptime-Kuma](/serveex/monitoring/uptime-kuma)
  ::
 
  ::card{icon=lucide:logs style="color: #1AD6FF;"}
  #title
  __Gestion des logs__
  #description
  [Installer et déployer Dozzle](/serveex/monitoring/dozzle)
  ::

  ::card{icon=noto:rabbit style="color: #1AD6FF;"}
  #title
  __Gestion de la connexion__
  #description
  [Installer et déployer Speedtest Tracker](/serveex/monitoring/speedtest-tracker)
  ::

  ::card{icon=lucide:chart-column-decreasing style="color:rgb(26, 255, 213);"}
  #title
  __Etat des ressources__
  #description
  [Installer et déployer Beszel](/serveex/monitoring/beszel)
  ::

  ::card{icon=lucide:circle-power style="color:rgb(228, 117, 117);"}
  #title
  __Wake on Lan__
  #description
  [Installer et déployer UpSnap](/serveex/monitoring/upsnap)
  ::
::

::card-grid
#title
Media

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=cbi:plex-alt style="color: rgb(229, 160, 13);"}
  #title
  __Media__
  #description
  [Installer et déployer Plex](/serveex/media/plex)
  ::
 
  ::card{icon=cbi:qbittorrent style="color: rgb(#2f67ba);"}
  #title
  __Seedbox__
  #description
  [Installer et déployer Qbittorrent](/serveex/media/qbittorrent)
  ::
::

::card-grid
#title
Cloud Drive & Photos

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=cib:nextcloud style="color: rgb(0, 104, 161);"}
  #title
  __Drive__
  #description
  [Installer et déployer Nextcloud](/serveex/cloud/nextcloud)
  ::
 
  ::card{icon=simple-icons:immich style="color: #ed79b5;"}
  #title
  __Photos__
  #description
  [Installer et déployer Immich](/serveex/cloud/immich)
  ::
::

::card-grid
#title
Fichiers & partage

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=noto:open-file-folder }
  #title
  __Explorateur de fichier__
  #description
  [Installer et déployer file-browser](/serveex/files/file-browser)
  ::

  ::card{icon=carbon:share style="color: #47428e;" }
  #title
  __Partage__
  #description
  [Installer et déployer Pingvin](/serveex/files/pingvin)
  ::

::


::card-grid
#title
Outils de développement

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=logos:visual-studio-code}
  #title
  __Visual Studio Code__
  #description
  [Installer et déployer code-server](/serveex/development/code-server)
  ::
 
  ::card{icon=simple-icons:gitea style="color: #9ee773;"}
  #title
  __Git Repository__
  #description
  [Installer et déployer Gitea](/serveex/development/gitea)
  ::

  ::card{icon=noto:hammer-and-wrench }
  #title
  __Outils__
  #description
  [Installer et déployer IT Tools](/serveex/development/it-tools)
  ::
::

::card-grid
#title
Applications utiles

#root
:ellipsis{left=0px width=40rem top=10rem blur=140px}

#default
 
  ::card{icon=cbi:adguard style="color: #67b279;"}
  #title
  __DNS anti-pub et filtres__
  #description
  [Installer et déployer Adguard Home](/serveex/apps/adguard)
  ::
 
  ::card{icon=cbi:bitwarden style="color: rgb(25 128 255);"}
  #title
  __Gestionnaire de mots de passe__
  #description
  [Installer et déployer Vaultwarden](/serveex/apps/vaultwarden)
  ::
::

## A venir
---
- Homepage, pour avoir tout vos services en un coup d'oeil et y accéder facilement
- Mkdocs pour votre documentation
- Docus, alternative à Mkdocs
- Speedtest-tracker pour vérifier la connexion de votre serveur
- UpSnap pour réveiller vos machines à distance